/*
Sakul - http://wwww.sakul.cz - SakulRaider@seznam.cz (2016)
Stopky v3.3 Odečítací
Arduino IDE v1.6.5
Firmware v1.0
------------------------------------------------------------
Dodělat:
        Nic o čem bych věděl

------------------------------------------------------------
Použit LCD s podsvícením 2X16 znaků připojený pomocí převodníku na I2C sběrnici.
Použita deska Arduino ProMini
Výstup pro externí displej s mím protokolem
Zadavatel: batti2@seznam.cz

Zadání:
-------
Display externí - Ten je jasný. Napájení 12V/2A DC a bezdrátový přenos ze stopek.
Stopky:
1. Namontovat do krabičky KM60.
2. Výstup na externí displej + bezdrátový přenos.
3. Napájení 8-12V/100mA DC
4. Zobrazení na malém LCD displeji 2x16 znaků.
5. Stopky budou po spuštění odpočítávat z přednastaveného času (MM:SS / Minuty:Sekundy).
6. 5 uložených přednastavených časů (hodnoty uchovat i při výpadku napětí).
7. Editace 5ti přednastavených časů.
8. Spuštění odpočtu Tlačítkem nebo externím vstupem (Laserová závora).
*/
// Knihovny ----------------------------------------------------------------------------------
#include <Wire.h>
#include <LCD.h>                                                     // Někdy je potřeba jindy ne (jsem z toho volaaky zmeteny)
#include <LiquidCrystal_I2C.h>
#include <EEPROM.h>
// -------------------------------------------------------------------------------------------

unsigned long time;                                                  // Pomocná proměnná pro časový program stopek
unsigned long lastJob1;                                              // Pomocná proměnná pro časování intervalu obnovy dat na displeji
unsigned long lastJob2;
unsigned long lastJob3;
unsigned long lastJob10;

long startTime;
long endTime;
long PauseLCD = 3000;                                                // Prodleva mezi rotací obrazovek na LCD (3000)

const int StartPin = 7;                                              // Tlačítko START
const int UpPin = 8;                                                 // Tlačítko UP
const int DownPin = 9;                                               // Tlačítko DOWN

int tlStart = 0;                                                     // Pomocné proměnné pro obsluhu tlačítek
int tlUp = 0;
int tlDown = 0;
int mTime;                                                           // Registry pro čas: Minuty
int sTime;                                                           // Sekundy
int msTime;                                                          // MiliSekundy
int minTime;
int secTime;
int adresa=0;                                                        // Počáteční adresa pro zápis nebo čtení do EEPROM

int secCas1=00;                                                      // Předvolby pevných časů odečtů
int minCas1=8;
int secCas2=00;;
int minCas2=12;
int secCas3=00;;
int minCas3=15;
int secCas4=00;;
int minCas4=18;
int secCas5=00;;
int minCas5=20;

byte VyberCasu=1;                                                    // Proměnná pro výběr předvolby času
byte byte1secCas1=0;                                                 // Pomocné registry pro zápis a čtení EEPROM
byte byte2secCas1=0;
byte byte1minCas1=0;
byte byte2minCas1=0;
byte byte1secCas2=0;
byte byte2secCas2=0;
byte byte1minCas2=0;
byte byte2minCas2=0;
byte byte1secCas3=0;
byte byte2secCas3=0;
byte byte1minCas3=0;
byte byte2minCas3=0;
byte byte1secCas4=0;
byte byte2secCas4=0;
byte byte1minCas4=0;
byte byte2minCas4=0;
byte byte1secCas5=0;
byte byte2secCas5=0;
byte byte1minCas5=0;
byte byte2minCas5=0;
byte TestEEPROM=0;
byte Radek=0;
byte Kurzor=1;
byte Poradi=1;

char cas[15];
char cas1[9];
char prednasCas1[9];
char prednasCas2[9];
char prednasCas3[9];
char prednasCas4[9];

boolean ChodStopky = false;                                          // Příznak chodu stopek
boolean PouzeJednou = false;                                         // Příznak blokování opětovného spuštění odpočtu (Stopek)
boolean Serizovani = false;                                          // Příznak seřizovacího režimu stopek

boolean pUp = false;                                                 // Pomocné pro tlačítka
boolean pDown = false;
boolean pStart = false;

// Konfigurace knihoven -----------------------------------------------------------------------
// Addr, En, Rw, Rs, d4, d5, d6, d7, backlighpin, polarity
LiquidCrystal_I2C lcd(0x20, 4, 5, 6, 0, 1, 2, 3, 7, NEGATIVE);      // Pro I2C desky s adresou 20 (SMD trimr jasu)
// LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);      // Pro I2C desky s adresou 27 (Modrý trimr jasu)
// -------------------------------------------------------------------------------------------
void setup() {
  Wire.begin();                           // Inicializace sběrnice I2C
  Serial.begin(19200);                    // Nastavení komunikační rychlosti s externím displejem

  pinMode(StartPin, INPUT_PULLUP);        // Definice vstupů/výstupů a jejich konfigurace
  pinMode(UpPin, INPUT_PULLUP);
  pinMode(DownPin, INPUT_PULLUP);
  tlStart = digitalRead(StartPin);         // Přečtení vstupu tlačítka start
  if (tlStart ==false){
    Serizovani = true;                     // Přechod do seřizovacího režimu
  }

  lcd.begin(16, 2);                        // Nastavení displeje 16 znaků na 2 řádky
  lcd.backlight();                         // Zapnout podsvícení displeje
  lcd.setCursor(0, 0);                     // Nastavit kurzor na první řádek a první znak
  lcd.print("Stopky verze 3.3");           // Nápis na první řádek
  lcd.setCursor(0, 1);                     // Nastaví kurzor na druhý řádek a první znak
  lcd.print("Firmware 1.0");               // 
  delay (PauseLCD);                        // Prodleva před přepnutím na další stránku
  lcd.clear();
  lcd.setCursor(0, 0);                     //
  lcd.print("  www.sakul.cz  ");
  lcd.setCursor(0, 1);                     //
  lcd.print(" Info@sakul.cz ");
  delay (PauseLCD);
  lcd.clear();
//  lcd.setCursor(0, 0);                     //
//  lcd.print("  www.sakul.cz  ");
//  lcd.setCursor(0, 1);                     //
//  lcd.print(" Info@sakul.cz ");
//  delay (PauseLCD);
//  lcd.clear();
  Serial.write(0 + 1);                       // Vypnout segmenty při inicializaci.
  Serial.write(0 + 2);
  Serial.write(0 + 3);                       
  Serial.write(0 + 4);
  Serial.write(0 + 5);                       
  Serial.write(0 + 6);

  adresa = 0;                                           // Snulování počítadla adresy paměti EEPROM
  TestEEPROM = EEPROM.read(adresa);                     // Kontrolní čtení EEPROM jestli je prázdná nebo už má nějaká data
  if (TestEEPROM == 255){
    EPROM();                                            // Je prázdná tak tam di něco nahrát
  }
  adresa = 0;                                           // Vynulování adresy pro čtení nebo zápis do EEPROM
  byte1secCas1 = EEPROM.read(adresa);                   // Načtení všech hodnot z EEPROM
  byte2secCas1 = EEPROM.read(adresa + 1);
  byte1minCas1 = EEPROM.read(adresa + 2);
  byte2minCas1 = EEPROM.read(adresa + 3);
  byte1secCas2 = EEPROM.read(adresa + 4);
  byte2secCas2 = EEPROM.read(adresa + 5);
  byte1minCas2 = EEPROM.read(adresa + 6);
  byte2minCas2 = EEPROM.read(adresa + 7);
  byte1secCas3 = EEPROM.read(adresa + 8);
  byte2secCas3 = EEPROM.read(adresa + 9);
  byte1minCas3 = EEPROM.read(adresa + 10);  
  byte2minCas3 = EEPROM.read(adresa + 11);
  byte1secCas4 = EEPROM.read(adresa + 12);
  byte2secCas4 = EEPROM.read(adresa + 13);
  byte1minCas4 = EEPROM.read(adresa + 14);  
  byte2minCas4 = EEPROM.read(adresa + 15);
  byte1secCas5 = EEPROM.read(adresa + 16);
  byte2secCas5 = EEPROM.read(adresa + 17);
  byte1minCas5 = EEPROM.read(adresa + 18);  
  byte2minCas5 = EEPROM.read(adresa + 19);
  VyberCasu = EEPROM.read(adresa + 20);

  secCas1 = byte1secCas1 + (byte2secCas1 << 8);         // Převod načtených hodnot z EEPROM do proměných
  minCas1 = byte1minCas1 + (byte2minCas1 << 8);
  secCas2 = byte1secCas2 + (byte2secCas2 << 8);
  minCas2 = byte1minCas2 + (byte2minCas2 << 8);
  secCas3 = byte1secCas3 + (byte2secCas3 << 8);
  minCas3 = byte1minCas3 + (byte2minCas3 << 8);
  secCas4 = byte1secCas4 + (byte2secCas4 << 8);
  minCas4 = byte1minCas4 + (byte2minCas4 << 8);
  secCas5 = byte1secCas5 + (byte2secCas5 << 8);
  minCas5 = byte1minCas5 + (byte2minCas5 << 8);
  
}
// --------------------------------------------------------------------------------------
void loop() {                                     // Hlavní program
  time = millis();
  Vstupy();                                       // 
  NaLCD();                                        // Řízení zobrazení na LCD
  Stopky();                                       // Podprogram počítání času
  PredvolbaCasu();                                // Předvolba času
  Nastaveni();                                    // Nastavování přednastavených hodnot
  ToExtDisp();                                    // Řízení zobrazení na externí display
//  EPROM();                                        // Zápis hodnot do EEPROM

//  UART();                                         // Testování a debugování programu

}
// --------------------------------------------------------------------------------------
void Vstupy() {
  tlStart = digitalRead(StartPin);               // Čtení digitálních vstupů
  tlUp = digitalRead(UpPin);
  tlDown = digitalRead(DownPin);

 if (Serizovani == false){                       // Kontrola zda je seřizovací režim
// ------------------------------------------------
   if (tlStart==false){                          // Spuštění odečtu
     if (pStart==false){
      if (ChodStopky==false){
         pStart=true;
         PouzeJednou = false;                    // Schození příznaku blokování opětovného spuštění odpočtu
         PredvolbaCasu();                        // Při novém spuštění načíst aktuální předvolbu do odpočtu
         ChodStopky=true;
         EEPROM.write(20, VyberCasu);            // Uložení aktuální předvoly času do EEPROM
         
  }}}
  else {pStart=false;}  
  
// ------------------------------------------------
   if (tlUp==false){                             // Volba přednastaveného času (UP-Nahoru)
     if (pUp==false){
      if (ChodStopky==false){
         pUp=true;
         PouzeJednou = false;                    // ???????
         VyberCasu++;
         if (VyberCasu==6){
          VyberCasu=1;
         }
         PredvolbaCasu();                        // Při novém spuštění načíst aktuální předvolbu do odpočtu ??????
         PouzeJednou = true;                     // ??????
  }}}
  else {pUp=false;}
// ------------------------------------------------
   if (tlDown==false){                           // Volba přednastaveného času (Down-Dolů)
     if (pDown==false){
      if (ChodStopky==false){
         pDown=true;
         PouzeJednou = false;                    // ???????
         VyberCasu--;
         if (VyberCasu==0){
          VyberCasu=5;
         }
         PredvolbaCasu();                        // Při novém spuštění načíst aktuální předvolbu do odpočtu ??????
         PouzeJednou = true;                     // ??????
  }}}
  else {pDown=false;}
// ------------------------------------------------
 }
}
// --------------------------------------------------------------------------------------
void Nastaveni(){                                // Hrozná vypíčenina to nastavování tlačítkama
 if (Serizovani==true){
  
   if (tlStart==false){                          // 
     if (pStart==false){
         pStart=true;
         Poradi++;
         }       
  }
  else {pStart=false;}
// -----------------------------
      if (Poradi >= 9){                         // Pokud jsou vsechny hodnoty protočeny vynuluj čítač
        Poradi=1;
        lcd.noBlink();
        lcd.clear();                            // Info na LCD displej
        lcd.setCursor(0, 0);
        lcd.print("Ukladam hodnoty");
        lcd.setCursor(0, 1);
        lcd.print("Aktualnich casu"); 
        EPROM();                                // Volání podprogramu pro uložení hodnot do EEPROM
        delay (PauseLCD);
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("Hodnoty ulozeny");
        lcd.setCursor(0, 1);
        lcd.print(" Stiskni RESET");
        delay (PauseLCD); 
        lcd.clear();
      }
// ----------------------------- 

// ----------------------------- 

      switch(Poradi) {                              // V týdle srandě se nastavuji uživatelské časy a kurzor
      case 1:
      Kurzor = 3;
      Radek = 0;
      if (tlUp==false){                             // Volba času (UP-Nahoru)
       if (pUp==false){
         pUp=true;
         minCas1++;
         if (minCas1>=100){
          minCas1=0;
         }
        }
       }
      else {pUp=false;}
      
      if (tlDown==false){                           // Volba času (DOWN-Dolů)
       if (pDown==false){
         pDown=true;
         minCas1--;
         if (minCas1<=-1){
          minCas1=99;
         }
        }
       }
      else {pDown=false;}
      break;
//-----------------------------      
      case 2:
      Kurzor = 6;
      Radek = 0;
      if (tlUp==false){                             // Volba času (UP-Nahoru)
       if (pUp==false){
         pUp=true;
         secCas1++;
         if (secCas1>=60){
          secCas1=0;
         }
        }
       }
      else {pUp=false;}
      
      if (tlDown==false){                           // Volba času (DOWN-Dolů)
       if (pDown==false){
         pDown=true;
         secCas1--;
         if (secCas1<=-1){
          secCas1=59;
         }
        }
       }
      else {pDown=false;}
      break;
//-----------------------------      
      case 3:
      Kurzor = 12;
      Radek = 0;
      if (tlUp==false){                             // Volba času (UP-Nahoru)
       if (pUp==false){
         pUp=true;
         minCas2++;
         if (minCas2>=100){
          minCas2=0;
         }
        }
       }
      else {pUp=false;}
      
      if (tlDown==false){                           // Volba času (DOWN-Dolů)
       if (pDown==false){
         pDown=true;
         minCas2--;
         if (minCas2<=-1){
          minCas2=99;
         }
        }
       }
      else {pDown=false;}
      break;
//-----------------------------      
      case 4:
      Kurzor = 15;
      Radek = 0;
      if (tlUp==false){                             // Volba času (UP-Nahoru)
       if (pUp==false){
         pUp=true;
         secCas2++;
         if (secCas2>=60){
          secCas2=0;
         }
        }
       }
      else {pUp=false;}
      
      if (tlDown==false){                           // Volba času (DOWN-Dolů)
       if (pDown==false){
         pDown=true;
         secCas2--;
         if (secCas2<=-1){
          secCas2=59;
         }
        }
       }
      else {pDown=false;}
      break;
//-----------------------------      
      case 5:
      Kurzor = 3;
      Radek = 1;
      if (tlUp==false){                             // Volba času (UP-Nahoru)
       if (pUp==false){
         pUp=true;
         minCas3++;
         if (minCas3>=100){
          minCas3=0;
         }
        }
       }
      else {pUp=false;}
      
      if (tlDown==false){                           // Volba času (DOWN-Dolů)
       if (pDown==false){
         pDown=true;
         minCas3--;
         if (minCas3<=-1){
          minCas3=99;
         }
        }
       }
      else {pDown=false;}
      break;
//-----------------------------      
      case 6:
      Kurzor = 6;
      Radek = 1;
      if (tlUp==false){                             // Volba času (UP-Nahoru)
       if (pUp==false){
         pUp=true;
         secCas3++;
         if (secCas3>=60){
          secCas3=0;
         }
        }
       }
      else {pUp=false;}
      
      if (tlDown==false){                           // Volba času (DOWN-Dolů)
       if (pDown==false){
         pDown=true;
         secCas3--;
         if (secCas3<=-1){
          secCas3=59;
         }
        }
       }
      else {pDown=false;}
      break;
//-----------------------------      
      case 7:
      Kurzor = 12;
      Radek = 1;
      if (tlUp==false){                             // Volba času (UP-Nahoru)
       if (pUp==false){
         pUp=true;
         minCas4++;
         if (minCas4>=100){
          minCas4=0;
         }
        }
       }
      else {pUp=false;}
      
      if (tlDown==false){                           // Volba času (DOWN-Dolů)
       if (pDown==false){
         pDown=true;
         minCas4--;
         if (minCas4<=-1){
          minCas4=99;
         }
        }
       }
      else {pDown=false;}
      break;
//-----------------------------      
      case 8:
      Kurzor = 15;
      Radek = 1;
      if (tlUp==false){                             // Volba času (UP-Nahoru)
       if (pUp==false){
         pUp=true;
         secCas4++;
         if (secCas4>=60){
          secCas4=0;
         }
        }
       }
      else {pUp=false;}
      
      if (tlDown==false){                           // Volba času (DOWN-Dolů)
       if (pDown==false){
         pDown=true;
         secCas4--;
         if (secCas4<=-1){
          secCas4=59;
         }
        }
       }
      else {pDown=false;}
      break;
}
// -----------------------------      
 } 
}

// --------------------------------------------------------------------------------------
void PredvolbaCasu() {                               // Výběr požadované časové předvolby
 if (Serizovani == false){                           // Kontrola zda je seřizovací režim
  if (PouzeJednou==false){                           // 
    if (ChodStopky==false){                          // Pouze pokud stopky neběží
     
    switch(VyberCasu) {
    case 1:
      secTime=secCas1;
      minTime=minCas1;
      sprintf(cas1, "%02d:%02d", minTime,secTime);   // Naformátování předvoleného času
      break;
    case 2:
      secTime=secCas2;
      minTime=minCas2;
      sprintf(cas1, "%02d:%02d", minTime,secTime);
      break;
    case 3:
      secTime=secCas3;
      minTime=minCas3;
      sprintf(cas1, "%02d:%02d", minTime,secTime);
      break;
    case 4:
      secTime=secCas4;
      minTime=minCas4;
      sprintf(cas1, "%02d:%02d", minTime,secTime);
      break;
    case 5: 
      secTime=secCas5;
      minTime=minCas5;
      sprintf(cas1, "%02d:%02d", minTime,secTime);
      break; 
    }
   }    
  }
 } 
}
// --------------------------------------------------------------------------------------
void Stopky() {                                  // Časový program
if (PouzeJednou == false){                       // Kontrola zda již odečet neběžel a není náhodou na nule.
  if (ChodStopky == true) {                      // Kontrola zda maji běžet stopky
   endTime = (time - startTime);                 // Počítání času dopředu dle lokálního času procesoru (millis)
   msTime = ( endTime % 1000L);                  // 
   sTime = ( endTime / 1000L); 
   if (sTime >= 1){                              // Jakmile dosáhne čas 1 vteřiny resetuj počítání času a odečti z 
    startTime=time;                              // přednastaveného času 1 vteřinu.
    secTime--;
   }
   if (secTime == -1){                           // Kontrola zda je odpočet sekund již pod nulou
    minTime--;                                   // V tom případě odečti 1 minutu z přednastaveného času a 
    secTime=59;                                  // přednastav znovu hodnotu sekund na 59.
   }
   if (secTime+minTime == 0){                    // Kontrola zda je odečet na 00:00
   ChodStopky = false;                           // pokud ano zastav chod stopek
   PouzeJednou = true;                           // Nahození příznaku blokování opětovného spuštění odpočtu
   }
 }

 }
}
// --------------------------------------------------------------------------------------
void NaLCD() {
  if (millis() > (300 + lastJob1)) {

    if (Serizovani == false){                                // Kontrola zda jsou stopky v seřizovacím nebo běžném režimu
                                                             // Běžný režim
    lcd.setCursor(0, 0);
    lcd.print("Predvolba: ");
    lcd.print(cas1);                                         // Zobrazení přednastaveného času

    lcd.setCursor(0, 1);
    lcd.print("Odecet: ");
    sprintf(cas, "%02d:%02d", minTime,secTime);              // Zformátování casu
    lcd.print(cas);                                          // Zobrazení aktuálního času odpočtu
    }
    
    else {                                                   // Seřizovací režim
    lcd.setCursor(0, 0);
    lcd.print("1-");
    sprintf(prednasCas1, "%02d:%02d", minCas1,secCas1);
    lcd.print(prednasCas1);
    lcd.print("  2-");
    sprintf(prednasCas2, "%02d:%02d", minCas2,secCas2);
    lcd.print(prednasCas2);
    lcd.setCursor(0, 1);
    lcd.print("3-");
    sprintf(prednasCas3, "%02d:%02d", minCas3,secCas3);
    lcd.print(prednasCas3);
    lcd.print("  4-");
    sprintf(prednasCas4, "%02d:%02d", minCas4,secCas4);
    lcd.print(prednasCas4);
    
    lcd.setCursor(Kurzor, Radek);                            // Nastaveni blikajiciho kurzoru
    lcd.blink();
    }
    
    lastJob1 = millis();
    
  }
}
// --------------------------------------------------------------------------------------
void ToExtDisp() {                            // Podprogram pro řízení zobrazení na externím displeji

  byte DeSekund;                              // Desítky sekund
  byte Sekundy;                               // Jednotky sekund
  byte DeMinut;                               // Desítky minut
  byte Minuty;                                // Jednotky minut

  byte sSekundy;                              // Pomocný registr pro převod na můj protokol k odeslání
  byte sDeSekund;
  byte sMinuty;
  byte sDeMinut;
  //--------------------------------------
                                              // Tato část plní data pro Ext. displej aktuálně běžícím časem
  Sekundy = (secTime % 10);
  DeSekund = (secTime / 10);
  Minuty = (minTime %10);
  DeMinut = (minTime /10);

  //--------------------------------------
                                              // Převedení časů na protokol malého a velkého displeje
  if (millis() > (100 + lastJob2)) {          // Aktualizace udajů na displeji každých 100ms (aby zbytečně nebyl zahlcen daty)

    byte odeslat;                             // Pomocný registr pro zkompilování a odeslání dat na malý displej

    sSekundy = (Sekundy + 1  << 4);           // Převod čísla na na BCD (Není klasické !!! Můj protokol)
    odeslat = sSekundy + 1;                   // K BCD číslu přidat adresu
    Serial.write(odeslat);                    // Zkompilovaný údaj odeslat do velkého displeje

    sDeSekund = (DeSekund + 1  << 4);
    odeslat = sDeSekund + 2;
    Serial.write(odeslat);

    sMinuty = (Minuty + 1  << 4);
    odeslat = sMinuty + 3;
    Serial.write(odeslat);

    sDeMinut = (DeMinut + 1  << 4);
    odeslat = sDeMinut + 4;
    Serial.write(odeslat);
    
//------------------ 
   byte dvojteckaON = 240;                   // Řízení dvojteček na displeji. Rovnou blika i ledkou na desce procesoru
   byte dvojteckaOFF = 0;
   
    if (msTime <= 500){                    
       Serial.write(dvojteckaON);            // Blika dvojtečkou na adrese O (Velký displej)
      }
       else {
       Serial.write(dvojteckaOFF);
     }
     if (ChodStopky == false){               // Pokud stopky stojí svítit s dvojtečkama
        Serial.write(dvojteckaON);           // 
       }
//------------------     

    lastJob2 = millis();
  }
}
// --------------------------------------------------------------------------------------

void EPROM() {                                      // Zápis hodnot do EEPROM
                                           
  byte1secCas1 = secCas1;                           // Rozdělení na jednotlivé byty pro zápis do EEPROM
  byte2secCas1 = secCas1 >> 8;
  byte1secCas2 = secCas2;
  byte2secCas2 = secCas2 >> 8;
  byte1secCas3 = secCas3;
  byte2secCas3 = secCas3 >> 8;
  byte1secCas4 = secCas4;
  byte2secCas4 = secCas4 >> 8;
  byte1secCas5 = secCas5;
  byte2secCas5 = secCas5 >> 8;
  byte1minCas1 = minCas1;                       
  byte2minCas1 = minCas1 >> 8;
  byte1minCas2 = minCas2;
  byte2minCas2 = minCas2 >> 8;
  byte1minCas3 = minCas3;
  byte2minCas3 = minCas3 >> 8;
  byte1minCas4 = minCas4;
  byte2minCas4 = minCas4 >> 8;
  byte1minCas5 = minCas5;
  byte2minCas5 = minCas5 >> 8;  

  adresa = 0;                                      // Snulování počítadla adresy paměti EEPROM
  EEPROM.write(adresa, byte1secCas1);              // Zápis dat do EEPROM
  EEPROM.write(adresa + 1, byte2secCas1);
  EEPROM.write(adresa + 2, byte1minCas1);
  EEPROM.write(adresa + 3, byte2minCas1);
  EEPROM.write(adresa + 4, byte1secCas2);
  EEPROM.write(adresa + 5, byte2secCas2);  
  EEPROM.write(adresa + 6, byte1minCas2);
  EEPROM.write(adresa + 7, byte2minCas2);
  EEPROM.write(adresa + 8, byte1secCas3);
  EEPROM.write(adresa + 9, byte2secCas3);
  EEPROM.write(adresa + 10, byte1minCas3);
  EEPROM.write(adresa + 11, byte2minCas3);
  EEPROM.write(adresa + 12, byte1secCas4);
  EEPROM.write(adresa + 13, byte2secCas4);  
  EEPROM.write(adresa + 14, byte1minCas4);
  EEPROM.write(adresa + 15, byte2minCas4);
  EEPROM.write(adresa + 16, byte1secCas5);
  EEPROM.write(adresa + 17, byte2secCas5);
  EEPROM.write(adresa + 18, byte1minCas5);
  EEPROM.write(adresa + 19, byte2minCas5);
  EEPROM.write(adresa + 20, VyberCasu);
   
}
// --------------------------------------------------------------------------------------

void UART() {                                   // Pouze testovací pro debugování programu

  if (millis() > (3000 + lastJob10)) {          // Interval vypisování dat na UART (1000ms) 

    Serial.print("EEPROM ADR1: ");              // 
    Serial.print(TestEEPROM);
    Serial.print(" / "); 
    Serial.print(byte1secCas1);
    Serial.print(" / ");
    Serial.print(byte1minCas1);
    Serial.print(" / ");
    Serial.print(byte2minCas1);
    Serial.print(" ::: CASY-");
    Serial.print(minCas1);
    Serial.print(":");
    Serial.print(secCas1);
    Serial.print(" ::: ");
    Serial.print(minCas2);
    Serial.print(":");
    Serial.print(secCas2);
    Serial.print(" ::: ");
    Serial.print(minCas3);
    Serial.print(":");
    Serial.print(secCas3);
    Serial.print(" ::: ");
    Serial.print(minCas4);
    Serial.print(":");
    Serial.print(secCas4);
    Serial.print(" ::: ");
    Serial.print(minCas5);
    Serial.print(":");
    Serial.println(secCas5);

    lastJob10 = millis();
  }
}
// --------------------------------------------------------------------------------------
